package com.ruoyi.project.patrol.commonuse.controller;

import com.ruoyi.common.utils.StringUtils;
import com.ruoyi.common.utils.file.ExcelUtils;
import com.ruoyi.common.utils.poi.ExcelUtil;
import com.ruoyi.framework.aspectj.lang.annotation.Log;
import com.ruoyi.framework.aspectj.lang.enums.BusinessType;
import com.ruoyi.framework.interceptor.annotation.RepeatSubmit;
import com.ruoyi.framework.web.controller.BaseController;
import com.ruoyi.framework.web.domain.AjaxResult;
import com.ruoyi.framework.web.page.TableDataInfo;
import com.ruoyi.project.patrol.commonuse.domain.TCommonuseTester;
import com.ruoyi.project.patrol.commonuse.service.ITCommonuseTesterService;
import com.ruoyi.project.patrol.dev.domain.TDevTester;
import com.ruoyi.project.patrol.dev.service.ITDevTesterService;
import com.ruoyi.project.patrol.patrol.domain.TPatrolIssues;
import com.ruoyi.project.patrol.patrol.domain.TPatrolPlan;
import com.ruoyi.project.patrol.patrol.service.ITPatrolIssuesService;
import com.ruoyi.project.patrol.patrol.service.ITPatrolPlanService;
import com.ruoyi.project.system.domain.SysUser;
import com.ruoyi.project.system.service.ISysUserService;
import org.apache.commons.collections4.CollectionUtils;
import org.apache.poi.ss.usermodel.*;
import org.apache.poi.ss.util.CellRangeAddress;
import org.apache.poi.xssf.usermodel.XSSFCell;
import org.apache.poi.xssf.usermodel.XSSFRow;
import org.apache.poi.xssf.usermodel.XSSFSheet;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import java.io.IOException;
import java.io.OutputStream;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.List;
import java.util.Objects;
import java.util.UUID;

/**
 * 检测仪检查记录Controller
 *
 * @author admin
 * @date 2023-11-03
 */
@RestController
@RequestMapping("/commonuse/tester")
public class TCommonuseTesterController extends BaseController {
    @Autowired
    private ITCommonuseTesterService tCommonuseTesterService;
    @Autowired
    private ITDevTesterService tDevTesterService;

    @Autowired
    private ITPatrolPlanService tPatrolPlanService;

    @Autowired
    private ITPatrolIssuesService tPatrolIssuesService;

    @Autowired
    private ISysUserService sysUserService;

    /**
     * 查询检测仪检查记录列表
     */
    @PreAuthorize("@ss.hasPermi('commonuse:tester:list')")
    @GetMapping("/list")
    public TableDataInfo list(TCommonuseTester tCommonuseTester) {
        startPage();
        if (StringUtils.isEmpty(tCommonuseTester.getIssuesFlag()))
            tCommonuseTester.setIssuesFlag("0");
        List<TCommonuseTester> list = tCommonuseTesterService.selectTCommonuseTesterList(tCommonuseTester);
        return getDataTable(list);
    }

    /**
     * 导出检测仪检查记录列表
     */
    
    @Log(title = "检测仪检查记录", businessType = BusinessType.EXPORT)
    @PostMapping("/export")
    public AjaxResult export(TCommonuseTester tCommonuseTester) {
        try {
            tCommonuseTester.setIssuesFlag("0");
            List<TCommonuseTester> list = tCommonuseTesterService.selectTCommonuseTesterListToExcel(tCommonuseTester);
            if (list.size() == 0) {
                return AjaxResult.error("暂无可导出数据");
            }
            XSSFWorkbook workbook = new XSSFWorkbook();
            XSSFSheet sheet = workbook.createSheet();// 设置列宽
            sheet.setColumnWidth(0, 1200);
            sheet.setColumnWidth(1, 4500);
            sheet.setColumnWidth(2, 3500);
            sheet.setColumnWidth(3, 3500);
            sheet.setColumnWidth(4, 3500);
            sheet.setColumnWidth(5, 4500);
            sheet.setColumnWidth(6, 4500);
            sheet.setColumnWidth(7, 3500);
            //第一行
            XSSFRow row1 = sheet.createRow(0);
            row1.createCell(0).setCellValue("CBP-6.3.0-SCFSH-020.21  Rev:04  2021/10/01");
            ExcelUtils.createVoidCell(1, 7, row1);
            sheet.addMergedRegion(new CellRangeAddress(0, 0, 0, 7));//合并
            //第二行
            XSSFRow row2 = sheet.createRow(1);
            row2.createCell(0).setCellValue("四合一/苯系物/硫化氢/二氧化碳/射线检测仪检查记录");
            ExcelUtils.createVoidCell(1, 7, row2);
            sheet.addMergedRegion(new CellRangeAddress(1, 1, 0, 7));
            //第三行
            XSSFRow row3 = sheet.createRow(2);
            row3.createCell(0).setCellValue("年度：" + tCommonuseTester.getYear());
            sheet.addMergedRegion(new CellRangeAddress(2, 2, 0, 3));
            ExcelUtils.createVoidCell(1, 7, row3);
            row3.createCell(4).setCellValue("检查频率：1次/3月");
            sheet.addMergedRegion(new CellRangeAddress(2, 2, 4, 7));
            //第四行
            XSSFRow row4 = sheet.createRow(3);
            row4.createCell(0).setCellValue("序号");
            row4.createCell(1).setCellValue("检测仪类型");
            row4.createCell(2).setCellValue("型号");
            row4.createCell(3).setCellValue("编号");
            row4.createCell(4).setCellValue("检查内容");
            ExcelUtils.createVoidCell(5, 7, row4);
            sheet.addMergedRegion(new CellRangeAddress(3, 3, 4, 7));
            //第五行
            XSSFRow row5 = sheet.createRow(4);
            sheet.addMergedRegion(new CellRangeAddress(3, 4, 0, 0));
            sheet.addMergedRegion(new CellRangeAddress(3, 4, 1, 1));
            sheet.addMergedRegion(new CellRangeAddress(3, 4, 2, 2));
            sheet.addMergedRegion(new CellRangeAddress(3, 4, 3, 3));
            ExcelUtils.createVoidCell(0, 3, row5);
            row5.createCell(4).setCellValue("检测仪外观及背夹完好度");
            row5.createCell(5).setCellValue("检测仪显示屏及电量");
            row5.createCell(6).setCellValue("检测仪有效期");
            row5.createCell(7).setCellValue("检查人");
            Long planId = null;
            //遍历数组赋值
            int startRow = 5;
            int endRow = 5;
            for (int i = 0; i < list.size(); i++) {
                TCommonuseTester tester = list.get(i);
                planId = tester.getPlanId();
                XSSFRow row = sheet.createRow(5 + i);
                row.createCell(0).setCellValue(i + 1);
                row.createCell(1).setCellValue(tester.getTesterType());
                row.createCell(2).setCellValue(tester.getTesterModel());
                row.createCell(3).setCellValue(tester.getTesterNo());
                row.createCell(4).setCellValue("1".equals(tester.getTesterBody()) ? "√" : tester.getTesterBody());
                row.createCell(5).setCellValue("1".equals(tester.getTesterEnergy()) ? "√" : tester.getTesterEnergy());
                row.createCell(6).setCellValue("1".equals(tester.getTesterSafeDate()) ? "√" : tester.getTesterSafeDate());
                XSSFCell cell10 = row.createCell(7);
                if (StringUtils.isNotEmpty(tester.getUpdaterCode())) {
                    SysUser sysUser = sysUserService.selectUserById(Long.valueOf(tester.getUpdaterCode()));
                    cell10.setCellValue(sysUser == null ? "" : sysUser.getNickName());
                }
                // 合并相同类型的单元格
                if (i != 0) {
                    if (tester.getTesterType().equals(list.get(i - 1).getTesterType())) {//当前行与上一行为同一类型时
                        endRow++;
                    } else {
                        if (startRow != endRow) {//当前合并开始行和结束行不为同一行时，合并
                            sheet.addMergedRegion(new CellRangeAddress(startRow, endRow, 1, 1));
                        }
                        startRow = ++endRow;// 开始行=结束行+1
                    }
                    if (i+1 == list.size()) {//最后一种类型
                        if (startRow != endRow)
                            sheet.addMergedRegion(new CellRangeAddress(startRow, endRow, 1, 1));
                    }
                }
            }
            String confirmed = "";
            Date confirmedDate = null;
            TPatrolPlan tPatrolPlan = tPatrolPlanService.selectTPatrolPlanById(planId);
            if (Objects.nonNull(tPatrolPlan) && Objects.nonNull(tPatrolPlan.getConfirmed())) {
                SysUser sysUser = sysUserService.selectUserById(Long.valueOf(tPatrolPlan.getConfirmed()));            if (sysUser!=null) {
                confirmed = sysUser.getSignUrl();
                confirmedDate = tPatrolPlan.getConfirmDate();
            }
            }
            // 循环后下一行
            int nextRowNum = 5 + list.size();
            XSSFRow row28 = sheet.createRow(nextRowNum);
            row28.setHeightInPoints(30);
            XSSFCell row28Cell1 = row28.createCell(0);
            row28Cell1.setCellValue("签名");
            ExcelUtils.createVoidCell(1, 2, row28);
            sheet.addMergedRegion(new CellRangeAddress(nextRowNum, nextRowNum, 0, 2));
            if (StringUtils.isNotEmpty(confirmed))
                ExcelUtils.insertPicture(workbook, sheet, confirmed, nextRowNum, 5, 1, 1);
            ExcelUtils.createVoidCell(3, 7, row28);
            sheet.addMergedRegion(new CellRangeAddress(nextRowNum, nextRowNum, 3, 7));
            // 下一行
            nextRowNum++;
            XSSFRow row29 = sheet.createRow(nextRowNum);
            row29.setHeightInPoints(30);
            XSSFCell row29Cell1 = row29.createCell(0);
            row29Cell1.setCellValue("日期");
            ExcelUtils.createVoidCell(1, 2, row29);
            sheet.addMergedRegion(new CellRangeAddress(nextRowNum, nextRowNum, 0, 2));
            row29.createCell(3).setCellValue(confirmedDate != null ? new SimpleDateFormat("yyyy-MM-dd").format(confirmedDate) : "");
            ExcelUtils.createVoidCell(4, 7, row29);
            sheet.addMergedRegion(new CellRangeAddress(nextRowNum, nextRowNum, 3, 7));

            // 设置单元格样式
            // 文字居中，自动换行，四周边框
            CellStyle style = workbook.createCellStyle();
            style.setAlignment(HorizontalAlignment.CENTER);
            style.setVerticalAlignment(VerticalAlignment.CENTER);
            style.setWrapText(true);
            style.setBorderTop(BorderStyle.THIN);
            style.setBorderBottom(BorderStyle.THIN);
            style.setBorderLeft(BorderStyle.THIN);
            style.setBorderRight(BorderStyle.THIN);

            // 设置垂直居中，四周边框
            CellStyle style2 = workbook.createCellStyle();
            style2.setVerticalAlignment(VerticalAlignment.CENTER);
            style2.setBorderTop(BorderStyle.THIN);
            style2.setBorderBottom(BorderStyle.THIN);
            style2.setBorderLeft(BorderStyle.THIN);
            style2.setBorderRight(BorderStyle.THIN);
            for (Row row : sheet) {
                row.setHeightInPoints(30);
                if (!sheet.getSheetName().contains("事故柜1")) {
                    if (row.getRowNum() == 4) {
                        row.setHeightInPoints(80);
                    }
                }
                if (row.getRowNum() == 0) {
                    continue;
                }
                if (row.getRowNum() == 2) {
                    for (Cell cell : row) {
                        if (cell.getColumnIndex() == 0 || cell.getColumnIndex() == 1 || cell.getColumnIndex() == 2)
                            cell.setCellStyle(style2);
                        else
                            cell.setCellStyle(style);
                    }
                } else {
                    for (Cell cell : row) {
                        cell.setCellStyle(style);
                    }
                }
            }
            nextRowNum++;
            XSSFRow row30 = sheet.createRow(nextRowNum);
            row30.createCell(0).setCellValue("说明：");
            ExcelUtils.createVoidCell(1, 8, row30);
            sheet.addMergedRegion(new CellRangeAddress(nextRowNum, nextRowNum, 0, 8));

            nextRowNum++;
            XSSFRow row31 = sheet.createRow(nextRowNum);
            row31.createCell(0).setCellValue("1.检查正常打“√”。");
            ExcelUtils.createVoidCell(1, 8, row31);
            sheet.addMergedRegion(new CellRangeAddress(nextRowNum, nextRowNum, 0, 8));

            nextRowNum++;
            XSSFRow row32 = sheet.createRow(nextRowNum);
            row32.createCell(0).setCellValue("2.检查有不正常情况打“X”，并记录存在问题，处理结果及完成时间。");
            ExcelUtils.createVoidCell(1, 8, row32);
            sheet.addMergedRegion(new CellRangeAddress(nextRowNum, nextRowNum, 0, 8));

            nextRowNum++;
            XSSFRow row33 = sheet.createRow(nextRowNum);
            row33.createCell(0).setCellValue("3. 检查频率为每3个月检查维护一次。");
            ExcelUtils.createVoidCell(1, 8, row33);
            sheet.addMergedRegion(new CellRangeAddress(nextRowNum, nextRowNum, 0, 8));

            //返回
            String fileName = "PSSR_16_便携式检测仪.xlsx";
            OutputStream os = Files.newOutputStream(Paths.get(ExcelUtil.getAbsoluteFile(fileName)));
            workbook.write(os);
            workbook.close();
            return AjaxResult.success(fileName);
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
    }

    /**
     * 获取检测仪检查记录详细信息
     */
    @PreAuthorize("@ss.hasPermi('commonuse:tester:query')")
    @GetMapping(value = "/{id}")
    public AjaxResult getInfo(@PathVariable("id") Long id) {
        return AjaxResult.success(tCommonuseTesterService.selectTCommonuseTesterById(id));
    }

    /**
     * 获取检测仪检查记录详细信息
     */
    @PreAuthorize("@ss.hasPermi('commonuse:tester:query')")
    @GetMapping(value = "/info")
    public AjaxResult getInfo(TCommonuseTester tCommonuseTester) {
        if (StringUtils.isNull(tCommonuseTester.getId()) || StringUtils.isNull(tCommonuseTester.getPlanId())) {
            return AjaxResult.error("id或计划id不能为空！");
        }
        TDevTester tDevTester = tDevTesterService.selectTDevTesterById(tCommonuseTester.getId());
        TCommonuseTester item = new TCommonuseTester();
        item.setPlanId(tCommonuseTester.getPlanId());
        item.setTesterNo(tDevTester.getTesterNo());
        item.setTesterType(tDevTester.getTesterType());
        item.setTesterModel(tDevTester.getTesterModel());
        item.setIssuesFlag("0");
        List<TCommonuseTester> list = tCommonuseTesterService.selectTCommonuseTesterList(item);
        if (CollectionUtils.isNotEmpty(list))
            return AjaxResult.success(list.get(0));
        return AjaxResult.error("此设备不在当前巡检计划中!");
    }

    /**
     * 新增检测仪检查记录
     */
    @PreAuthorize("@ss.hasPermi('commonuse:tester:add')")
    @Log(title = "检测仪检查记录", businessType = BusinessType.INSERT)
    @PostMapping
    public AjaxResult add(@RequestBody TCommonuseTester tCommonuseTester) {
        return toAjax(tCommonuseTesterService.insertTCommonuseTester(tCommonuseTester));
    }

    /**
     * 修改检测仪检查记录
     */
    @PreAuthorize("@ss.hasPermi('commonuse:tester:edit')")
    @Log(title = "检测仪检查记录", businessType = BusinessType.UPDATE)
    @PutMapping
    @RepeatSubmit
    public AjaxResult edit(@RequestBody TCommonuseTester tCommonuseTester) {
        tCommonuseTester.setUpdatedate(new Date());
        tCommonuseTester.setUpdaterCode(getUserId().toString());
        tCommonuseTester.setCheckStatus("1");
        tCommonuseTester.setCheckDate(new Date());
        TCommonuseTester item = tCommonuseTesterService.selectTCommonuseTesterById(tCommonuseTester.getId());
        TPatrolPlan tPatrolPlan = tPatrolPlanService.selectTPatrolPlanById(tCommonuseTester.getPlanId());
        if (tPatrolPlan.getStatus() == 1) {
            return AjaxResult.error("当前选择的计划已确认！");
        }
        if (!"1".equals(item.getCheckStatus())) {
            tPatrolPlan.setUncheckedNum(tPatrolPlan.getUncheckedNum() - 1);
            tPatrolPlan.setCheckedNum(tPatrolPlan.getCheckedNum() + 1);
            tPatrolPlanService.updateTPatrolPlan(tPatrolPlan);
        }
        if ((StringUtils.isNotEmpty(tCommonuseTester.getTesterEnergy()) && !"1".equals(tCommonuseTester.getTesterEnergy())) ||
                (StringUtils.isNotEmpty(tCommonuseTester.getTesterBody()) && !"1".equals(tCommonuseTester.getTesterBody())) ||
                (StringUtils.isNotEmpty(tCommonuseTester.getTesterSafeDate()) && !"1".equals(tCommonuseTester.getTesterSafeDate()))) {
            tCommonuseTester.setIssuesStatus("1");
            tCommonuseTester.setCheckStatus("0");
            tCommonuseTesterService.updateTCommonuseTester(tCommonuseTester);
            tCommonuseTester.setIssuesFlag("1");
            tCommonuseTester.setCheckStatus("1");
            tCommonuseTester.setCreatedate(new Date());
            tCommonuseTester.setCreaterCode(getUserId().toString());
            tCommonuseTester.setTesterNo(item.getTesterNo());
            tCommonuseTester.setTesterModel(item.getTesterModel());
            tCommonuseTester.setTesterType(item.getTesterType());
            tCommonuseTesterService.insertTCommonuseTester(tCommonuseTester);
            TPatrolIssues tPatrolIssues = new TPatrolIssues();
            tPatrolIssues.setPatrolType("18");
            tPatrolIssues.setDevDescribe(tCommonuseTester.getTesterType() + " " + tCommonuseTester.getTesterModel() + " " + tCommonuseTester.getTesterNo());
            tPatrolIssues.setLinkId(tCommonuseTester.getId());
            tPatrolIssues.setStatus(0L);
            tPatrolIssuesService.insertTPatrolIssues(tPatrolIssues);
        } else {
            if ("1".equals(item.getIssuesStatus())) {
                TPatrolIssues tPatrolIssues = new TPatrolIssues();
                tPatrolIssues.setPatrolType("18");
                tPatrolIssues.setDevDescribe(item.getTesterType() + " " + item.getTesterModel() + " " + item.getTesterNo());
                tPatrolIssues.setCreatedate(new Date());
                for (TPatrolIssues patrolIssues : tPatrolIssuesService.selectTPatrolIssuesList(tPatrolIssues)) {
                    patrolIssues.setStatus(1L);
                    tPatrolIssuesService.updateTPatrolIssues(patrolIssues);
                }
            }
            tCommonuseTester.setIssuesStatus("0");
            tCommonuseTesterService.updateTCommonuseTester(tCommonuseTester);
        }
        return AjaxResult.success();
    }

    /**
     * 删除检测仪检查记录
     */
    @PreAuthorize("@ss.hasPermi('commonuse:tester:remove')")
    @Log(title = "检测仪检查记录", businessType = BusinessType.DELETE)
    @DeleteMapping("/{ids}")
    public AjaxResult remove(@PathVariable Long[] ids) {
        return toAjax(tCommonuseTesterService.deleteTCommonuseTesterByIds(ids));
    }
}
